aboutsummaryrefslogtreecommitdiffstats
path: root/soong.bash
diff options
context:
space:
mode:
authorColin Cross <ccross@android.com>2015-03-25 14:43:57 -0700
committerColin Cross <ccross@android.com>2015-03-26 14:13:49 -0700
commit68f55102dadc880e2b57c669415771395ac0c3b0 (patch)
tree1dcbe3dd29a50bdb22d3750ef0633fe29186c3f6 /soong.bash
parentf7531f1a21aaa56ef53cb1714e954e487528109f (diff)
downloadbuild_soong-68f55102dadc880e2b57c669415771395ac0c3b0.tar.gz
build_soong-68f55102dadc880e2b57c669415771395ac0c3b0.tar.bz2
build_soong-68f55102dadc880e2b57c669415771395ac0c3b0.zip
Support dependencies on environment variables
Ninja can't depend on environment variables, so modifying build behavior based on environment variables requires coordinating between the soong script that invokes ninja and the soong_build manifest generator. Allow any module to call Config.Getenv to get the contents of an environment variable while registering a dependency on it. After all modules have been processed write out the state of all used environment variables to a JSON file called .soong.environment. During the next build the soong script will use the soong_env tool to compare the contents of .soong.environment to the current environment, and force a build manifest regeneration by deleting the .soong.environment file if any variables have changed. Change-Id: Id0d81933a857bc2fc1cd7a393a3c6cec73dc4824
Diffstat (limited to 'soong.bash')
-rwxr-xr-xsoong.bash17
1 files changed, 17 insertions, 0 deletions
diff --git a/soong.bash b/soong.bash
index fc330d0b..fab15de5 100755
--- a/soong.bash
+++ b/soong.bash
@@ -27,4 +27,21 @@ fi
# can regenerate the build manifest.
export BLUEPRINT_NINJA_HAS_MULTIPASS=1
+# Ninja can't depend on environment variables, so do a manual comparison
+# of the relevant environment variables from the last build using the
+# soong_env tool and trigger a build manifest regeneration if necessary
+ENVFILE=${BUILDDIR}/.soong.environment
+ENVTOOL=${BUILDDIR}/.bootstrap/bin/soong_env
+if [ -f ${ENVFILE} ]; then
+ if [ -x ${ENVTOOL} ]; then
+ if ! ${ENVTOOL} ${ENVFILE}; then
+ echo "forcing build manifest regeneration"
+ rm -f ${ENVFILE}
+ fi
+ else
+ echo "Missing soong_env tool, forcing build manifest regeneration"
+ rm -f ${ENVFILE}
+ fi
+fi
+
${SRCDIR}/prebuilts/ninja/${PREBUILTOS}/ninja -C ${BUILDDIR} "$@"